unit thread_splash_form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,thread_splash_scanline,PackList_Bitmaps,th_ti;

type
  TFormThreadSplash = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure WndProc (var message: TMessage); override;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    BTOut:TBitmap; //  
    BT:Tbitmap;    //-

    bt_tmp_rgb,bt_tmp_a:tbitmap; //    

    DC:HDC;

    ftext:string;
    fprogress:integer;

    FPackListBitmaps:TPackListBitmaps;

    //  
    Status_timer:TThread_timer;
    transparent,fclose,transparent_old:integer;

    procedure RenderForm(bb:byte);
    procedure SetSizeBitmap(w,h:integer);

    procedure Status_timer_out(Sender: TObject);
    procedure check_status;
  public
    
    procedure Draw_splash;
    procedure SetProgress(value:integer);
    procedure SetText(text:string);
    procedure CloseSplash;
  end;

implementation

{$R *.dfm}

procedure TFormThreadSplash.FormCreate(Sender: TObject);
begin
 // ,   ,     
 BTOut:=TBitmap.Create;
 BTOut.PixelFormat:=pf32bit;

 //-,       
 //     :)
 BT:=TBitmap.Create;
 BT.PixelFormat:=pf32bit;

 //         24- ,   
 //  32 ,        
 bt_tmp_rgb:=TBitmap.Create;
 bt_tmp_a:=TBitmap.Create;
 bt_tmp_rgb.PixelFormat:=pf32bit;
 bt_tmp_a.PixelFormat:=pf32bit;

 // ,  ,   ,    
 BT.LoadFromFile( extractfilepath( application.ExeName )+'bitmaps\back.bmp' );
 BT.PixelFormat:=pf32bit;
 SetSizeBitmap(BT.Width,BT.Height);

 //    
 FPackListBitmaps:=TPackListBitmaps.Create;
 FPackListBitmaps.Load(extractfilepath( application.ExeName )+'bitmaps\icons.txt');
 {
 //     ,    :)
 FPackListBitmaps.Add_bitmap_from_file(extractfilepath( application.ExeName )+'bitmaps\ico1.bmp');
 FPackListBitmaps.Add_bitmap_from_file(extractfilepath( application.ExeName )+'bitmaps\ico2.bmp');
 FPackListBitmaps.Add_bitmap_from_file(extractfilepath( application.ExeName )+'bitmaps\ico3.bmp');
 FPackListBitmaps.Add_bitmap_from_file(extractfilepath( application.ExeName )+'bitmaps\ico4.bmp');
 FPackListBitmaps.Add_bitmap_from_file(extractfilepath( application.ExeName )+'bitmaps\ico5.bmp');
 FPackListBitmaps.Save(extractfilepath( application.ExeName )+'bitmaps\icons.txt');
 }

 
 ftext:='';
 fprogress:=0;

 //        RenderForm  
 //,   ,        :)
 DC:=GetDC(0);

 fclose:=0;
 transparent:=0;
 transparent_old:=255;
 Status_timer:=TThread_timer.Create;
 Status_timer.OnTimer:=Status_timer_out;
 Status_timer.Interval:=15;
 check_status;
end;

procedure TFormThreadSplash.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 BTOut.Free;
 BT.Free;
 bt_tmp_rgb.Free;
 bt_tmp_a.Free;
 FPackListBitmaps.Free;
 Status_timer.Free;
 Action:=caFree;
end;

procedure TFormThreadSplash.WndProc (var message: TMessage);
begin
  case message.Msg of
     WM_WINDOWPOSCHANGED: begin
         SetWindowPos(Handle,HWND_TOPMOST,Left,Top,Width,Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE );
         sleep(1);
     end;
  end;
   inherited;
end;

procedure TFormThreadSplash.SetSizeBitmap(w,h:integer);
begin
 BTOut.Width:=w;
 BTOut.Height:=h;

 bt_tmp_rgb.Width:=w;
 bt_tmp_rgb.Height:=h;

 bt_tmp_a.Width:=w;
 bt_tmp_a.Height:=h;
end;

procedure TFormThreadSplash.RenderForm(bb:byte);
var zsize:TSize; zpoint:TPoint; zbf:TBlendFunction;
    TopLeft: TPoint;
begin
  SetWindowLong(Handle, GWL_EXSTYLE, GetWindowLong(Handle, GWL_EXSTYLE) or WS_EX_LAYERED);

  width:=BTOut.Width;
  height:=BTOut.Height;

  zsize.cx := BTOut.Width;
  zsize.cy := BTOut.Height;
  zpoint := Point(0,0);

  with zbf do begin
    BlendOp := AC_SRC_OVER;
    BlendFlags := 0;
    AlphaFormat := AC_SRC_ALPHA;
    SourceConstantAlpha :=bb;
  end;
  TopLeft:=BoundsRect.TopLeft;

  UpdateLayeredWindow(Handle,DC,@TopLeft,@zsize,BTOut.Canvas.Handle,@zpoint,0,@zbf, ULW_ALPHA);
end;



procedure TFormThreadSplash.FormMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
const SC_DRAGMOVE : Longint = $F012;
begin
  ReleaseCapture;
  SendMessage(Handle, WM_SYSCOMMAND, SC_DRAGMOVE, 0);
end;

procedure TFormThreadSplash.SetText(text:string);
begin
 ftext:=text;
end;

procedure TFormThreadSplash.SetProgress(value:integer);
begin
 fprogress:=value;
 if(fprogress<0) then fprogress:=0 else
 if(fprogress>100) then fprogress:=100;
end;


procedure TFormThreadSplash.Draw_splash;
var l:integer; i,xx,cou:integer;
begin
 //    -   ""  RGB
 // .       ( BT)
 GetLayerBitmap(bt,bt_tmp_rgb,bt_tmp_a);

 // -      -   
 //     "" .     
 //   ,  clgray -    ( 50%)
 bt_tmp_rgb.Canvas.Brush.Style:=bsclear;
 bt_tmp_rgb.Canvas.Pen.Color:=clwhite;
 bt_tmp_rgb.Canvas.Rectangle(17,96,bt_tmp_rgb.Width-19,bt_tmp_rgb.Height-78);

 bt_tmp_a.Canvas.Brush.Style:=bsclear;
 bt_tmp_a.Canvas.Pen.Color:=clwhite;
 bt_tmp_a.Canvas.Rectangle(17,96,bt_tmp_a.Width-19,bt_tmp_a.Height-78);
 //       :
 // bt_tmp_a.SaveToFile(extractfilepath( application.ExeName )+'bt_tmp_a.bmp');
 //          
 //       :)

 //  
 l:=(bt_tmp_rgb.Width-19-17)-4;
 if(fprogress>0) then begin
   bt_tmp_rgb.Canvas.Brush.Style:=bssolid;
   bt_tmp_rgb.Canvas.Pen.Color:=clwhite;
   bt_tmp_rgb.Canvas.Brush.Color:=clwhite;
   bt_tmp_rgb.Canvas.Rectangle(17+2,96+2,17+2+trunc(l*(fprogress/100)),96+2+12-4);

   bt_tmp_a.Canvas.Brush.Style:=bssolid;
   bt_tmp_a.Canvas.Pen.Color:=clwhite;
   bt_tmp_a.Canvas.Brush.Color:=clwhite;
   bt_tmp_a.Canvas.Rectangle(17+2,96+2,17+2+trunc(l*(fprogress/100)),96+2+12-4);
 end;

 //, ""  -      ,    (   grayscale)
 if(ftext<>'') then begin
   bt_tmp_rgb.Canvas.Brush.Style:=bsclear;
   bt_tmp_rgb.Canvas.Font.Name:='Tahoma';

   //,    :)
   bt_tmp_rgb.Canvas.Font.Color:=$6C6C39;
   bt_tmp_rgb.Canvas.TextOut(100+1,78+1,ftext);

   bt_tmp_rgb.Canvas.Font.Color:=clwhite;
   bt_tmp_rgb.Canvas.TextOut(100,78,ftext);

   //     ,   (,    grayscale
   //   , .. clgray - 50% ),    
   //  -       
   bt_tmp_a.Canvas.Brush.Style:=bsclear;
   bt_tmp_a.Canvas.Font.Color:=clwhite;
   bt_tmp_a.Canvas.Font.Name:='Tahoma';
   bt_tmp_a.Canvas.TextOut(100,78,ftext);
 end;

 //     32-,    
 Build32(bt_tmp_rgb,bt_tmp_a,BTOut);

 // .   ,     
 //    ,   , .. 
 //     ,    
 // .
 //,     ,   
 // :)
 if(FPackListBitmaps.GetCountBitmaps>0) then begin
  xx:=22;
  cou:=100 div FPackListBitmaps.GetCountBitmaps;

  for i:=0 to FPackListBitmaps.GetCountBitmaps-1 do begin
   if(cou*i<=fprogress)and(cou*(i+1)>fprogress) then begin
      CopyBitmapAlfa32to32_gray( FPackListBitmaps.GetBitmap(i).Bitmap,BTOut,xx ,118, trunc( (fprogress-cou*i)*100/cou ) );
    end else
     if(cou*i<fprogress) then
      CopyBitmapAlfa32to32_gray( FPackListBitmaps.GetBitmap(i).Bitmap,BTOut,xx ,118,100 );
    xx:=xx+FPackListBitmaps.GetBitmap(i).Bitmap.Width+4;
  end;
 end;

 //     ...
 RenderForm(transparent);
 //   -    0..255,
 //           :)
end;

procedure TFormThreadSplash.Status_timer_out(Sender: TObject);
var _stop:boolean;
begin
_stop:=true;

 if (fclose=1) then begin
  if(transparent>0) then begin
       _stop:=false;
       transparent:=transparent-10; if(transparent<0) then transparent:=0;
       RenderForm(transparent);
   end;
  if(_stop) then Status_timer.Enabled:=false;
  exit;
 end;

 if(transparent<255) then begin
   if(transparent<transparent_old) then begin
        _stop:=false;
        transparent:=transparent+10;
        if(transparent>transparent_old) then transparent:=transparent_old;
        RenderForm(transparent);
    end else begin
        transparent:=transparent_old;
        RenderForm(transparent);
        _stop:=false;
    end;
 end;

if(_stop) then Status_timer.Enabled:=false;
end;

procedure TFormThreadSplash.check_status;
begin
if not(Status_timer.Enabled) then Status_timer.Enabled:=true;
end;

procedure TFormThreadSplash.CloseSplash;
begin
 fclose:=1;
 check_status;
end;

end.
