unit thread_splash_scanline;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,Forms,Graphics;

const
  MaxPixelCountA = MaxInt div SizeOf(TRGBQuad);
type
  PRGBAArray = ^TRGBAArray;
  TRGBAArray = array[0..MaxPixelCountA-1] of TRGBQuad;

  procedure CopyBitmapAlfa32to32_gray(_B_in,_B_out:Tbitmap; _x,_y,per:integer);
  procedure GetLayerBitmap(_B_res:TBitmap;  _Brgb,_Bmask:Tbitmap);
  procedure Build32(_B_in,_B_inM:TBitmap; _Bout:Tbitmap);
  
implementation

procedure CopyBitmapAlfa32to32_gray(_B_in,_B_out:Tbitmap; _x,_y,per:integer);
var x, y: Integer; _r,_b,_g:integer;
    w_in,h_in,w_out,h_out,tmp,x_cor,y_cor,x_corS,y_corS: Integer;
    RowOut,RowIn:PRGBAArray;
    _d,_dd:double;
begin
 w_in:=_B_in.Width;
 h_in:=_B_in.Height;
 w_out:=_B_out.Width;
 h_out:=_B_out.Height;
 if (_x)>w_out-1 then exit; if (_x+w_out)<0 then exit;
 if (_y)>h_out-1 then exit; if (_y+h_out)<0 then exit;

 if _x<0 then x_corS:=abs(_x) else x_corS:=0;
 if _y<0 then y_corS:=abs(_y) else y_corS:=0;
 if (_x+w_in)>w_out then x_cor:=_x+w_in-w_out else x_cor:=0;
 if (_y+h_in)>h_out then y_cor:=_y+h_in-h_out else y_cor:=0;

  y_cor:=h_in-1-y_cor;
  tmp:=w_in-1-x_cor; _dd:=(100/255)/100*(per/100);
  for y:=y_corS to y_cor do begin
     RowOut:= _B_out.ScanLine[y+_y];
     RowIn:= _B_in.ScanLine[y];
    for x:=x_corS to tmp do begin
         _d:=RowIn[x].rgbReserved*_dd;

          _r:= trunc(RowOut[x+_x].rgbRed+((RowIn[x].rgbRed-RowOut[x+_x].rgbRed)*_d));
         if _r>255 then _r:=255 else if _r<0 then _r:=0;

         _g:= trunc(RowOut[x+_x].rgbGreen+((RowIn[x].rgbGreen-RowOut[x+_x].rgbGreen)*_d));
         if _g>255 then _g:=255 else if _g<0 then _g:=0;

         _b:= trunc(RowOut[x+_x].rgbBlue+((RowIn[x].rgbBlue-RowOut[x+_x].rgbBlue)*_d));
         if _b>255 then _b:=255 else if _b<0 then _b:=0;

          RowOut[x+_x].rgbRed:=_r;
          RowOut[x+_x].rgbGreen:=_g;
          RowOut[x+_x].rgbBlue:=_b;
        if RowOut[x+_x].rgbReserved<(trunc(RowIn[x].rgbReserved*(per/100))) then RowOut[x+_x].rgbReserved:=trunc(RowIn[x].rgbReserved*(per/100));

  end; end;
end;

procedure GetLayerBitmap(_B_res:TBitmap;  _Brgb,_Bmask:Tbitmap);
var x, y: Integer; RowOut,RowIn,RowOutM: PRGBAArray;
begin
  for y:=0 to _B_res.Height-1 do begin
    RowOut:= _Brgb.ScanLine[y];
    RowOutM:= _Bmask.ScanLine[y];
    RowIn:= _B_res.ScanLine[y];
    for x:=0 to _B_res.Width-1 do begin

     RowOutM[x].rgbReserved:=255;
     RowOutM[x].rgbBlue:=RowIn[x].rgbReserved;
     RowOutM[x].rgbGreen:=RowIn[x].rgbReserved;
     RowOutM[x].rgbRed:=RowIn[x].rgbReserved;

     RowOut[x].rgbReserved:=255;
     RowOut[x].rgbBlue:=RowIn[x].rgbBlue;
     RowOut[x].rgbGreen:=RowIn[x].rgbGreen;
     RowOut[x].rgbRed:=RowIn[x].rgbRed;
     end;
  end;
end;

procedure Build32(_B_in,_B_inM:TBitmap; _Bout:Tbitmap);
var x, y: Integer; RowOut: PRGBAArray; RowIn,RowM:PRGBAArray;
begin
  for y:=0 to _B_in.Height-1 do begin
     RowOut:= _Bout.ScanLine[y];
     RowIn:= _B_in.ScanLine[y];
     RowM:= _B_inM.ScanLine[y];
    for x:=0 to _B_in.Width-1 do begin
          RowOut[x].rgbBlue:=RowIn[x].rgbBlue;
          RowOut[x].rgbGreen:=RowIn[x].rgbGreen;
          RowOut[x].rgbRed:=RowIn[x].rgbRed;
          RowOut[x].rgbReserved:=RowM[x].rgbRed;
    end;
  end;
end;

end.
